#include <Arduino.h>
#define PORT PWM_2
class HallButton // TODO
{
public:
  HallButton(byte pin) {};
  void Pulse(unsigned long time, bool high = false)
  {
    if (high)
    {
      highTime = time - lastRead;
    }
    else
    {
      fallCount++;
      lowTime = time - lastRead;
    }
    if (fallCount >= 2)
    {
      fallCount = 0;
      percent = 100 * lowTime / (lowTime + highTime);
    }
    lastRead = time;
  }
  byte fallCount;
  // private:
  bool isWaitingForHigh;
  unsigned long lastRead;
  unsigned long lowTime;
  unsigned long highTime;
  unsigned int lowDuration;
  bool isClicked()
  {
    if (activatedPercent == 0 && abs(previousPercent - percent) >= threshold)
    {
      activatedPercent = percent;
      return true;
    }
    else if (activatedPercent != 0 && abs(activatedPercent - percent) >= percent)
    {
      activatedPercent = 0;
      return false;
    }
    return true;
  }
  byte threshold = 2;
  byte activatedPercent;
  byte percent;
  byte previousPercent;
};

HallButton myHallButton[2] = {HallButton(3), HallButton(5)};
void gpio_callback(uint gpio, uint32_t events)
{
  byte hallButtonIndex = gpio == 3 ? 0 : 1;
  byte secondHallButtonIndex = hallButtonIndex == 0 ? 1 : 0;
  unsigned long timer = micros();
  myHallButton[hallButtonIndex].Pulse(timer, events == GPIO_IRQ_EDGE_RISE);
  myHallButton[secondHallButtonIndex].Pulse(timer, gpio_get(secondHallButtonIndex == 1 ? 5 : 3));
}

void setup()
{
  gpio_set_irq_enabled_with_callback(3, GPIO_IRQ_EDGE_FALL | GPIO_IRQ_EDGE_RISE, true, &gpio_callback);
  gpio_set_irq_enabled(5, GPIO_IRQ_EDGE_FALL | GPIO_IRQ_EDGE_RISE, true);
  _gpio_init(5);
  gpio_set_input_enabled(5, true);
  gpio_pull_up(5);
  _gpio_init(3);
  gpio_set_input_enabled(3, true);
  gpio_pull_up(3);
  Serial.begin(9600);
}

void loop()
{
  // int width = myHallButton[0].percent;
  // Serial.println(String(width));
  // if (Serial.available() > 0)
  //   parseSerial();
  // uint64_t timer = millis();
  // if (timer > flag + 100)
  // {
  // flag = timer;
  for (size_t i = 0; i < 2; i++)
  {
    Serial.print(String(myHallButton[i].percent) + "\t" + String(myHallButton[i].lowTime) + "\t" + String(myHallButton[i].highTime) + "\t");
  }
  Serial.print("\n");
  // }
}
